<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of DotClear.
# Copyright (c) 2004 Olivier Meunier and contributors. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

define ('old_dc_version','1.2.4');
define ('new_dc_version','1.2.5');

$plugins_root = dirname(__FILE__).'/../';
$plugins = new plugins($plugins_root);
$plugins->getPlugins(false);

$fileslist = array(
	'VERSION',
	'LISEZMOI.txt',
	'CHANGELOG',
	'inc/magic_strip.php',
	'inc/libs/lib.util.php',
	'layout/prepend.php',
);

/*
$fileslist = array(
	'VERSION'
);//*/

class dcPatch {
	function replace($f) {
		$oldf = str_replace('ecrire',DC_ECRIRE,dirname(__FILE__).'/../../../'.$f);
		$newf = dirname(__FILE__).'/files/'.$f;

		if (copy($newf,$oldf)) {
			return TRUE;
		} else {
			return FALSE;
		}
	}
}

buffer::str('<h2>'.__('patch ').new_dc_version.'</h2>');

if (DC_VERSION != old_dc_version) {
	buffer::str(
		'<p>'.__('This patch can only be applied on Dotclear v').old_dc_version.
		__(', anyway, a security patch will still be applied. If you don\'t see a green check below, please do a complete upgrade.').
		'</p>'
	);	
	if (substr(DC_VERSION,0,3) == '1.2') {
		$file = 'inc/magic_strip.php';
		$img_check = '<img src="images/check_%s.png" alt="" />';
		$result = (dcPatch::replace($file) ? 'on' : 'off');
		buffer::str(
		'<p>'.sprintf($img_check,$result).' '.
		$file.'</p>'
		);
		$plugins->switchStatus('patch125');
		buffer::str('<p>'.__('This  plugin has now de-activated itself. '.
			'You may remove it through the plugin manager.').'</p>');
	}
} else {
	$img_check = '<img src="images/check_%s.png" alt="" />';
	buffer::str('<p>'.__('Updating your files').'</p>');

	foreach ($fileslist as $file) {
		$result = (dcPatch::replace($file) ? 'on' : 'off');
			buffer::str(
			'<p>'.sprintf($img_check,$result).' '.
			$file.'</p>'
			);
	}
	buffer::str('<p>'.__('Your blog is now updated. Should you see a red cross '.
		'(denoting a file that could not be updated, leading to an unstable '.
		'installation) please manually upload the files (see the <i>files</i> '.
		'subdirectory of this plugin) or do a complete upgrade.').'</p>');
	$plugins->switchStatus('patch125');
	buffer::str('<p>'.__('This  plugin has now de-activated itself. '.
		'You may remove it through the plugin manager.').'</p>');
}
?>